"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MotifSpace = void 0;
const abstract_signer_1 = require("@ethersproject/abstract-signer");
const typechain_1 = require("@motif-foundation/asset/dist/typechain");
const addresses_1 = require("./addresses");
const utils_1 = require("./utils");
class MotifSpace {
    constructor(signerOrProvider, chainId) {
        if (abstract_signer_1.Signer.isSigner(signerOrProvider)) {
            this.readOnly = false;
        }
        else {
            this.readOnly = true;
        }
        this.signerOrProvider = signerOrProvider;
        this.chainId = chainId;
        const network = (0, utils_1.chainIdToNetworkName)(chainId);
        this.spaceAddress = addresses_1.addresses[network].space;
        this.spaceExchangeAddress = addresses_1.addresses[network].spaceExchange;
        this.space = typechain_1.SpaceFactory.connect(this.spaceAddress, signerOrProvider);
        this.spaceExchange = typechain_1.SpaceExchangeFactory.connect(this.spaceExchangeAddress, signerOrProvider);
    }
}
exports.MotifSpace = MotifSpace;
//# sourceMappingURL=MotifSpace.js.map